10 REM N1II MARCH 18, 1996 A2D3
20 REM THIS SOFTWARE MAKES A D/A CONVERSION AND
30 REM READS IT THROUGH THE PARALLEL
40 REM PRINTER PORT ON A PC
50 REM ***********************
60 REM INITIAL SETUP
70 SCREEN 0                     	'PICK 80 COLUMN TEXT MODE
80 COLOR 2, 0                   	'I LIKE GREEN ON BLACK
90 CLS                         		'FIRST CLEAR THE SCREEN
100 CLEAR                       		'THEN CLEAR ALL VARIABLES
105 PORTO = &H3BC                       'DEFINE OUTPUT PORT
110 DEFINT C-O                  	'ALL VARIB. STARTING W/ C-O ARE INTEGERS
200 '*************************   THIS IS THE START OF THE PROGRAM
300 REM Sin function generation
310 Q=1:R=0                            'if Q=1 then there will be 360 samples
320 R=R+Q                               'sample value
330 IF R>=360 THEN R=0                  'if sample>360 degrees, reset r to 0 deg
340 ANG=(22/7)*(R/360)*2                'form an angle in radians, 0 to 2 pi
350 AIN=SIN(ANG)                        'take the sine of the angle
360 AIN=AIN+1!                        'offset to eliminate negative values
400 REM k slows down the sin wave - decreases the output frequency
410 K=0                             'max allowable value is approx 32,000
420 REM FOR L=0 TO K:NEXT L
1990 CIN=(AIN/2)*255
2000 '**************************  NOW GET 8 BIT WORD OF CIN
2010 IF CIN>127 THEN D7=1:CIN=CIN-128    	'BIT 7
2020 IF CIN>63  THEN D6=1:CIN=CIN-64     	'BIT 6
2030 IF CIN>31  THEN D5=1:CIN=CIN-32     	'BIT 5
2040 IF CIN>15  THEN D4=1:CIN=CIN-16     	'BIT 4
2050 IF CIN>7   THEN D3=1:CIN=CIN-8      	'BIT 3
2060 IF CIN>3   THEN D2=1:CIN=CIN-4      	'BIT 2
2070 IF CIN>1   THEN D1=1:CIN=CIN-2      	'BIT 1
2080 IF CIN=1   THEN D0=1                		'BIT 0
2090 '******************        	SET UP FOR  CONVERSION
2100 OUT PORTO,2                	'CS(NOT) HIGH, CONTROL BIT LOW
2110 OUT (PORTO=2),2            	'CLOCK LINE LOW
2120 OUT PORTO,0                	'CS(NOT) LOW, CONTROL LOW  (=0)
2130 FOR N=1 TO 7               	'SET UP FOR 7
2140 GOSUB 2380                 	'CLOCK PULSES
2150 NEXT N
2160 OUT PORTO,1                	'CS(NOT) LOW, CONTROL HIGH (=1)
2170 GOSUB 2380                 	'GET ANOTHER CLOCK
2180 '******************        		 NOW FOR  DATA BITS
2190 OUT PORTO,D7                       'OUTPUT D7 (DATA, MSB FIRST)
2200 GOSUB 2380                 	'CALL A CLOCK
2210 OUT PORTO,D6               	'OUTPUT D6
2220 GOSUB 2380                 	'CALL A CLOCK
2230 OUT PORTO,D5
2240 GOSUB 2380
2250 OUT PORTO,D4
2260 GOSUB 2380
2270 OUT PORTO,D3
2280 GOSUB 2380
2290 OUT PORTO,D2
2300 GOSUB 2380
2310 OUT PORTO,D1
2320 GOSUB 2380
2330 OUT PORTO,D0               	'LAST DATA BIT (LSB)
2340 GOSUB 2380
2350 OUT PORTO,2                	'CS(NOT)HIGH, DATA/CONTROL LOW
2360 '                          		     EXCUTES CONVERSION
2367 D7=0:D6=0:D5=0:D4=0:D3=0:D2=0:D1=0:D0=0
2370 GOTO 320
2380 '*****************	CLOCK PULSE ROUTINE
2390 CD=1				'SET CLOCK WIDTH
2400 OUT (PORTO+2),0                    'SET PIN 14 (AUTOLF(NOT)) HIGH
2410					'THIS SETS CLOCK HIGH
2420 FOR CW = 0 TO CD STEP 1:NEXT CW		'SET CLOCK WIDTH
2430 OUT (PORTO+2),2                    'SET PIN 14 LOW (END OF CLOCK)
2440 RETURN
